import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";

var deserializeInitialState = function deserializeInitialState(viewModels, serializedInitialState) {
  var initialState = _objectSpread({}, serializedInitialState, {
    viewModels: _objectSpread({}, serializedInitialState.viewModels)
  });

  for (var viewModelIndex = 0; viewModelIndex < viewModels.length; viewModelIndex++) {
    var _viewModels$viewModel = viewModels[viewModelIndex],
        viewModelName = _viewModels$viewModel.name,
        deserializeState = _viewModels$viewModel.deserializeState;
    var viewModelInitialState = initialState.viewModels[viewModelName];

    for (var aggregateId in viewModelInitialState) {
      if (viewModelInitialState.hasOwnProperty(aggregateId)) {
        viewModelInitialState[aggregateId] = deserializeState(viewModelInitialState[aggregateId]);
      }
    }
  }

  return initialState;
};

export default deserializeInitialState;
//# sourceMappingURL=deserialize_initial_state.js.map