"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _reduxSaga = _interopRequireDefault(require("redux-saga"));

var _root_saga = _interopRequireDefault(require("./root_saga"));

var _empty_saga = _interopRequireDefault(require("./empty_saga"));

var _create_api = _interopRequireDefault(require("./create_api"));

var createResolveMiddleware = function createResolveMiddleware() {
  var sagaMiddleware = (0, _reduxSaga.default)();
  var sagaMiddlewareRun = sagaMiddleware.run.bind(sagaMiddleware);

  var sagaRunInternal = function sagaRunInternal(sagaArgs) {
    var api = (0, _create_api.default)(sagaArgs);
    var queryIdMap = new Map();
    sagaMiddlewareRun(sagaArgs.isClient ? _root_saga.default : _empty_saga.default, (0, _objectSpread2.default)({}, sagaArgs, {
      queryIdMap: queryIdMap,
      api: api
    }));
  };

  Object.defineProperty(sagaMiddleware, 'run', {
    get: function get() {
      return sagaRunInternal;
    },
    set: function set(value) {
      return sagaMiddlewareRun = value.bind(sagaMiddleware);
    }
  });
  return sagaMiddleware;
};

var _default = createResolveMiddleware;
exports.default = _default;
//# sourceMappingURL=create_resolve_middleware.js.map